	Program Overpass
*
c     This routine was originally written in Meteorological Fortran (MeteFor)
c     in order to use MeteFor's vector and matrix notation.  This routine is also
c     maintained in MeteFor.  The source code appearing below was generated by
c     the MeteFor processor, not by manual entry.  Some of the original code
c     may appear in statements which have been commented out.  The original
c     MeteFor source (with suffix .hlf) is more readable and better documented.
c     See the document MeteFor.doc
*
c                             F W Nagle  (fredn@ssec.wisc.edu)
c     ---------------------------------------------------------------------------------
	implicit double precision(d)
	character*8 csat
	character*4 cmode
*     VECTOR (F)VNORAX,(F)VCOORD,UK/0.,0.,1./,(F)VNADIR,(F)UNIT4
	real uk(3)/0.,0.,1./
	real vq41(3),vq42(3)
	real  vdl(3),vpos(3),vnad(3),ue(3),un(3)
	dimension xdum(16),vel(3)
	common/e1/xdum,vel
*
	equivalence(vdl(1),gdlat),(dum,xdum(1))
cxr   fltarg,numarg,dtmjdn,vnorax,vnadir,vcoord,inbox,unit4,tcivil
cxr   dtepoc,arctan,tcivil
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	call getarg(1,csat)
*
	if(csat.eq.'help'.or.csat.eq.'HELP')then
	write(*, '(/'' overpass yymmdd  satellite  lower-left-L/L'',
     x  ''   upper-right L/L''/)')
	stop
	end if
*
	jdate = argnum(1)
	call getarg(2,csat)
	sla1 = fltarg(3)
	slo1 = fltarg(4)
	sla2 = fltarg(5)
	slo2 = fltarg(6)
	dt0 = dtmjdn(jdate/10000, mod(jdate/100,100), mod(jdate,100),
     x  0,0,0)
	npass = 1
	inx = 0
c***	write(*, '(/'' Satellite: '', a8/)') csat
*
	do   2 n=0,1440
	nn = n
	dt = dt0 + dflt(nn)/1440.d+0
*     VPOS = VNORAX(DT, CSAT, SLAT,SLONG,CD)
	call vnorax(dt,csat,slat,slong,cd,vpos)
*
*     VNAD = VNADIR(VPOS)
	call vnadir(vpos,vnad)
*
*     VDL = VCOORD(DT, VNAD, 'CDL')
	call vcoord(dt,vnad,'CDL',vdl)
	in = inbox(sla1,slo1, gdlat,slong, sla2,slo2)
*
	if(in.eq.0)then
	if(inx.eq.0)go to     2
*
	inx = 0
*     NPASS = & + 1
	npass=npass+1
	go to     2
	end if
*
c***	if(inx == 0)
c***     x  write(*, '(/''      '',9x''Date  Time'',6x,''Sub-Satl Point'',
c***     x  ''      Alt'',  ''     Head'', ''    Speed'', '' Mode''/)')
	inx = in
	call tcivil(dt, jy,jm,jd,kh,km,sec,nth)
*     ALT = [VPOS - VNAD]
	vq41(1) = vpos(1)-vnad(1)
	vq41(2) = vpos(2)-vnad(2)
	vq41(3) = vpos(3)-vnad(3)
	rq41=rv4qq(vq41)
	alt=rq41
*     SPD = [VEL]
	rq41=rv4qq(vel)
	spd=rq41
*     UE = UNIT4(UK <X> VPOS)
	vq41(1) = uk(2)*vpos(3) - vpos(2)*uk(3)
	vq41(2) = uk(3)*vpos(1) - vpos(3)*uk(1)
	vq41(3) = uk(1)*vpos(2) - vpos(1)*uk(2)
	call unit4(vq41,ue)
*
*     UN = UNIT4(VPOS <X> UE)
	vq41(1) = vpos(2)*ue(3) - ue(2)*vpos(3)
	vq41(2) = vpos(3)*ue(1) - ue(3)*vpos(1)
	vq41(3) = vpos(1)*ue(2) - ue(1)*vpos(2)
	call unit4(vq41,un)
	cmode = 'Asc '
	rq41=ang4qq(vel(1),un(1))
	if(rq41.gt.90.)cmode = 'Desc'
	rq41=un(1)*vel(1)+un(2)*vel(2)+un(3)*vel(3)
	rq42=ue(1)*vel(1)+ue(2)*vel(2)+ue(3)*vel(3)
	head=arctan(rq41,rq42)+360.
c***	write(*,'(1h ,i4,i8,4(1x,i2.2),2x,2f9.2,f9.1,f9.2,f9.3,3x,a1)')
c***     x  npass,jy,jm,jd,kh,km, gdlat,slong,alt,head,spd,cmode

	write(*,'(2(i2.2))') kh,(km/5)*5

    2 continue
*
	dte = dtepoc(dum )
	call tcivil(dte, jy,jm,jd,kh,km,sec,nth)
c***	write(*, '(/'' Epoch of Orbital Parameters: '',
c***     x  i5,4i3,f6.1)') jy,jm,jd,kh,km,sec
c***	write(*, '('' Sub-Satellite Latitudes Are Geodetic.''/)')
c***	write(*, '('' ...done'')')
	stop
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function FLTARG(jpos)
c
c     To fetch the jpos-th input argument (like IPP in McIdas)
c     as a REAL
	Character*1 cinput(80), ch
	Character*80 cin
	equivalence(cin,cinput(1))
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	cin  = ' '
	call getarg(jpos, cin)
	kol = 1
	jsign = 1
	nfrac = 0
	kpt = 0
	mag = 0
*
	if(cinput(1) == '-') then
	kol = 2
	jsign = -1
	end if
c
	do n = 1,32
	 ch = cinput(kol)
	 if(ch == ' ') go to 4
*
	 if(ch == '.') kpt = 1
	 ich = ichar(ch)
*
	 if(ich>=48 .and. ich<=57) then
	  mag = 10*mag + ich - 48
	  nfrac = nfrac + kpt
	 end if
c
	 kol = kol + 1
	end do
c
4     flt = jsign*mag
	if(nfrac > 0) flt = flt / (10. ** nfrac)
	fltarg = flt
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Double Precision Function DTMJDN(myrx,mon,mday,jhour,jmin,jsec)
*
c     To compute the Modified Julian Day Number (MJDN), based on
c     the epoch of 00z 1 January 1970:
*
*     The Modified Julian Day Number is the Julian Day Number
c     of a given date, with the JDN of 12z 1 Jan 1970 subtracted.
*
*      The last 3 arguments may be either REAL*4 or INTEGER*4.
*
*     This routine should not be used for dates earlier than
c     1 January 1970.
*
	Implicit None
	Double Precision djul,dhour,dmin,dsec
	Real hour,fmin,sec
	Integer khour,kmin,ksec,imax,myr,myrx,jhour,jmin,jsec,kalday
	Integer mday,jday,month,mon,jcode,m100,mod,m400,m4,m,ndm
	Integer julday
*
	equivalence(khour,hour),(kmin,fmin),(ksec,sec)
	save
	data imax/16777216/
cxr   julday
c     xxxxxxxxxxxxxxxxxxxxxxxxxxx
	myr = myrx
	khour = jhour
	kmin = jmin
	ksec = jsec
	if(khour .lt. imax)hour = khour
	if(kmin .lt. imax)fmin = kmin
	if(ksec .lt. imax)sec = ksec
	kalday = mday
	jday = kalday
	month = mon
	if(mon .ne. 0) go to 10
*
	jcode = 1115212
	m100 = mod(myr,100)
	m400 = mod(myr,400)
	m4 = mod(myr,4)
	if(m400.eq.0 .or. (m4.eq.0 .and. m100.ne.0))jcode = 1115208
*
	do 12 m = 1,12
	month = m
	ndm = 31 - mod(jcode,4)
	jday = jday - ndm
	if(jday.le.0) go to 20
*
12    jcode = jcode/4
*
20    kalday = jday + ndm
*
	if(month.gt.12.or.kalday.gt.31)then
	write(*, '('' DTMJDN: month & day:'', 2i8)') month,kalday
	stop 99
	end if
*
10    djul = julday(myr, month, kalday) - 2440588
	dhour = hour
	dmin = fmin
	dsec = sec
	djul = djul + (dhour + dmin/60.d+0 + dsec/3600.d+0)/24.d+0
	dtmjdn = djul - .5d+0
	if(djul .le. 0.d+0)dtmjdn = 0.d+0
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Subroutine VNADIR(vsat,vqadir)
*
cxr   vcoord,vec4,arctan,geodet,erad84
*     Given a celestial or terrestrial satellite position vector,
c     this routine computes in the same coordinate system the
c     position vector of the point on the ground at the satellite
c     nadir, taking into account the ellipsoidal shape of the
c     earth.   This point in general is not at the geocentric
c     latitude of the satellite.
*
	implicit double precision(d)
	parameter (smajx=6378.388, sminx=6356.911946,
     1  b=sminx/smajx, b2=b*b, d0=0.d+0, epsi=.000001)
	integer jqmax/z'7fffffff'/
	real vqadir(3)
*     vector (f)vcoord,(f)vec4
	real vq41(3),vq42(3)
	real  vbl(3),vsat(3),vll(3),vs(3),vtan(3),vg(3),view(3)
	save
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
*     vbl = vsat
	vbl(1) = vsat(1)
	vbl(2) = vsat(2)
	vbl(3) = vsat(3)
*
*     vll = vcoord(d0, vbl, 'TLL')
	call vcoord(d0,vbl,'TLL',vq41)
	vll(1) = vq41(1)
	vll(2) = vq41(2)
	vll(3) = vq41(3)
*
	gclat = vll(1)
	kase = 0
	if(abs(gclat).lt.45.)kase=1
	if(kase.eq.0)then
*
*      vs = vbl/smajx
	vq41(1) = vbl(1)/smajx
	vq41(2) = vbl(2)/smajx
	vq41(3) = vbl(3)/smajx
	vs(1) = vq41(1)
	vs(2) = vq41(2)
	vs(3) = vq41(3)
*
*      vs = vec4(sqrt(vs(1)**2 + vs(2)**2), abs(vs(3)), 0.)
	rq41=vs(1)
	rq42=vs(2)
	rq43=rq41**2
	rq44=rq42**2
	rq45=rq43+rq44
	call vec4(sqrt(rq45),abs(vs(3)),0.,vq41)
	vs(1) = vq41(1)
	vs(2) = vq41(2)
	vs(3) = vq41(3)
*
	 c = b
	 c2 = b2
	   else
*
*      vs = vbl/sminx
	vq41(1) = vbl(1)/sminx
	vq41(2) = vbl(2)/sminx
	vq41(3) = vbl(3)/sminx
	vs(1) = vq41(1)
	vs(2) = vq41(2)
	vs(3) = vq41(3)
*
*      vs = vec4( abs(vs(3)), sqrt(vs(1)**2 + vs(2)**2), 0.)
	rq41=vs(1)
	rq42=vs(2)
	rq43=rq41**2
	rq44=rq42**2
	rq45=rq43+rq44
	call vec4(abs(vs(3)),sqrt(rq45),0.,vq41)
	vs(1) = vq41(1)
	vs(2) = vq41(2)
	vs(3) = vq41(3)
*
	 c = 1./b
	 c2 = 1./b2
	end if
	x = vs(1)/sqrt(vs(1)*vs(1) + vs(2)*vs(2))
	xl = x + .01
	sdotj = vs(2)
	vtan(1) = 1.
	vtan(3) = 0.
*
*     do until(abs(x-xl) < epsi)
	do   2  kq0001 = 1,jqmax
	if(abs(x-xl).lt.epsi)go to 4
*
	 x2 = x*x
	 radic = sqrt(1. - x2)
*
*      vg = vec4(x, c*radic, 0.)
	rq41=c*radic
	call vec4(x,rq41,0.,vq41)
	vg(1) = vq41(1)
	vg(2) = vq41(2)
	vg(3) = vq41(3)
*
*      view = vs - vg
	vq41(1) = vs(1)-vg(1)
	vq41(2) = vs(2)-vg(2)
	vq41(3) = vs(3)-vg(3)
	view(1) = vq41(1)
	view(2) = vq41(2)
	view(3) = vq41(3)
*
	 vtan(2) = -x*c/radic
*
*      prod =  view*vtan
	rq41=view(1)*vtan(1)+view(2)*vtan(2)+view(3)*vtan(3)
	prod=rq41
*
*      if(abs(prod) <= 0.) exit
	if(abs(prod).le.0.)then
	go to     4
	end if
	 pp = -c*(x2/(radic**3) + radic)*sdotj - 1. + c2
	 xl = x
	 x = x - prod/pp
    2 continue
*
4     y = c*sqrt(1. - x*x)
	if(kase.eq.0)then
	 elat = sign(1.,gclat)*arctan(x,y)
	   else
	 elat = sign(1.,gclat)*arctan(y,x)
	end if
	rad = erad84(geodet(elat))
*
*     vnadir = vcoord(d0, vec4(elat, vll(2), rad), 'LLT')
	call vec4(elat,vll(2),rad,vq41)
	call vcoord(d0,vq41,'LLT',vq42)
	vqadir(1) = vq42(1)
	vqadir(2) = vq42(2)
	vqadir(3) = vq42(3)
*
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Subroutine VCOORD(dt,vecin,cmode,  vecout)
*
*     13 Jan 08; NSC
cxr   sine,cosine,geodet,geocen,arctan,verneq
* -----------------------------------------------------------------
* DOCUMENTATION:
*
* Cooperative Institute for Meteorological Satellite Studies
* University of Wisconsin
* 1225 W Dayton Street
* Madison, Wisconsin  53706      USA
*
* Name: VCOORD; a subroutine-type subprogram
*       This is a vector-valued function under MeteFor.
*
* Inputs: Time, Double Precision, in Julian Day Number
*         or Modified Julian Day Number (MJDN)
*     a real,  3-dimensional vector in some coordinate system
*     a character*3 variable stating the desired transformation
*
*     12 Jan 00: Modified Julian Day Number (from epoch of
*     1 Jan 70) is also accepted.
*
* Output: a 3-dimensional real(single) transformed vector
*
* Usage:
*     To inter-convert among various coordinate systems:
*      cmode = LLC         Geocentric Lat/Long to Celestial
*      cmode = LLT         Geocentric Lat/Long to Terrestrial
*      cmode = CT          Celestial to Terrestrial
*      cmode = DLC         Geodetic Lat/Long to Celestial
*      cmode = DLT         Geodetic Lat/Long to Terrestrial
*
*     and the inverses of these operations:  (CLL, TLL, TC, CDL, TDL)
*
*     Note regarding time:  An input value for time (dt) is required
*     only if the celestial coordinate system is involved, either as
*     input or output coordinates.  If the transformation is
*     strictly between Lat/Long/CD on the one hand, and terrestrial
*     on the other, a dummy value of time (e.g. zero) can be used.
*
* Modules:  verneq, sine, cosine, arctan, geodet, geocen
*
* Comment:  The three coordinate systems treated by this routine are
*   defined as follows:
*
*   Celestial: The x-coordinate is directed from the center of
*   the earth toward the Vernal Equinox.  The y-coordinate is
*   directed 90 deg east of the x-coordinate, and the z-coordinate
*   is directed from the earth's center toward the North Pole.
*   The three coordinates form a right-hand orthonormal system.
*   This frame of reference is in constant rotation with respect to
*   the earth, and fixed with respect to the stars.
*
*   Terrestrial: The x-coordinate is directed from the earth's center
*   toward the Greenwich meridian; the y-coordinate is directed
*   90 deg east of the x-coordinate; the z coordinate is directed
*   from the earth's center toward the north pole.  The terrestrial
*   coordinates are a right-hand orthonormal system.
*   This frame of reference is fixed with respect to the earth.
*
*   Latitude/Longitude:  The three components are latitude in
*   degrees, positive north; longitude in degrees, positive east;
*   and radius vector in arbitrary units from the earth's center
*   to a given point.  These coordinates are not orthogonal
*   vectors.  The coordinates are vectors only in the sense that
*   they are three ordered real numbers.  The latitude may be either
*   geocentric or geodetic, depending on the conversion mode.
*
*     F W Nagle, SSEC, Univ of Wisc
*  ---------------------------------------------------------------------
	double precision dt,deqr2,deqrad
	character*3 cmodes(10),cmode
	dimension vecin(3),vecout(3),vecinp(3)
	save
	data cmodes/'LLC', 'LLT', 'CT ', 'CLL', 'TLL', 'TC ',
     x  'DLC', 'DLT', 'CDL', 'TDL'/
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	kdetic = 0
	lm = 0
*
	do   2 j=1,10
	lm = j
	if(cmodes(j)(1:3).eq.cmode(1:3)) go to 8
    2 continue
*
	write(*, '('' VCOORD: Unrecognized Transformation: '',
     1  a3)') cmode
	return
*
8     jtest = (lm-1)*(lm-3)*(lm-4)*(lm-6)*(lm-7)*(lm-9)
	velong= 0.
*
	if(jtest.eq.0)then
	if(dt.gt.2.6d+6 .or. dt.lt.0.d+0) go to 920
	if(dt.gt.100000.d+0.and.dt.lt.2.4d+6) go to 920
	velong= verneq(dt)
	end if
*
	do   4 j=1,3
4     vecinp(j) = vecin(j)
*
	if(lm.eq.7.or.lm.eq.8)then
	lm=lm-6
	vecinp(1)=geocen(vecinp(1))
	end if
*
	if(lm.ge.9)then
	lm=lm-5
	kdetic = 1
	end if
*
	if(lm.ge.4)lm=3-lm
	if(iabs(lm).gt.1) go to 50
	if(lm.lt.0) go to 20
*
10    if(abs(vecinp(1)).gt.90.)then
	write(*, '('' VCOORD: Bad input latitude: '', f12.2)')
     1  vecinp(1)
	go to 922
	end if
*
	deqrad = vecinp(3) * cosine(vecinp(1))
	clong = vecinp(2) - velong
	vecout(1) = deqrad * cosine(clong)
	vecout(2) = deqrad * sine(clong)
	vecout(3) = vecinp(3) * sine(vecinp(1))
	return
*
20    clong = arctan(vecinp(1), vecinp(2))
	deqr2 = dble(vecinp(1))**2 + dble(vecinp(2))**2
	eqr = dsqrt(deqr2)
	vecout(1) = arctan(eqr, vecinp(3))
	vecout(2) = clong + velong
	if(vecout(2).lt.-180.) vecout(2) = vecout(2)+360.
	if(vecout(2).gt.180.) vecout(2) = vecout(2)-360.
	vecout(3) = dsqrt(deqr2 + dble(vecinp(3))**2)
	if(kdetic.gt.0) vecout(1)=geodet(vecout(1))
	return
*
50    if(iabs(lm).gt.2) go to 100
	if(lm.lt.0) go to 20
	go to 10
*
100   if(lm.lt.0) go to 110
*
102   vecout(3) = vecinp(3)
	clong = arctan(vecinp(1), vecinp(2))
	glong = clong + velong
	deqrad = dsqrt(dble(vecinp(1))**2 + dble(vecinp(2))**2)
	vecout(1) = deqrad * cosine(glong)
	vecout(2) = deqrad * sine(glong)
	return
*
110   velong = -velong
	go to 102
*
920   write(*, '('' VCOORD: The input time is wrong: '', 1pd20.10)')
     1  dt
*
922   vecout(1) = 0.
	vecout(2) = 0.
	vecout(3) = 0.
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	FUNCTION INBOX(SLAT1,SLONG1,  FLAT,FLONG,  SLAT2,SLONG2)
*
*     If flat,flong falls within the lat/long box whose lower
c     left corner is slat1,slong1 and whose upper right corner
c     is slat2,slong2, then '1' is returned; and '0' otherwise.
*
	if(flat.lt.slat1.or.flat.gt.slat2) then
	inbox = 0
*
	  else
	inbox = lngtst(slong1, flong, slong2)
	end if
*
	return
	end
c	rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Subroutine Unit4(vec,uvec)
*
*     2 Apr 03; to compute the norm of an arbitrary vector:
*
	real vec(3),uvec(3)
	equivalence(jr2,r2),(sum2,jsum2)
*     data j$01/z'20000000'/             dec 536870912
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	sum2 = vec(1)*vec(1) + vec(2)*vec(2) + vec(3)*vec(3)
*
	if(sum2 .gt. 0.)then
	jr2 = jsum2/2 + 536870912
*
	do 2 n = 1,6
	r1 = r2
2     r2 = .5*(r1 + sum2/r1)
*
	do 4 j = 1,3
4     uvec(j) = vec(j)/r2
*
	    else
	do 6 j = 1,3
6     uvec(j) = 0.
*
	write(*, '('' UNIT4: Warning - the given vector argument has '',
     1  ''zero length.'')')
	end if
*
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Subroutine TCIVIL(dtime,  nyr,nmo,nda,nhr,min,sec,  nthday)
*
*     SFS
*     TCIVIL - to convert Double Precision time in JDN or MJDN to time
c     expressed in civil units.  Nthday varies from 1 to 366.
*     This differs from TINVER in that seconds are returned as
c     REAL*4, and hence may be fractional.
c     A four-digit year nyr is returned.
*
	Implicit None
	Double Precision dtime,dt,dfrac,dflt
	Real secs,fksecs,frac,fnsec,sec
	Integer jdt,jdtx,nyr,nmo,nda,nthday,ksecs,nhr,min,nsec
*
	character*4 cmon
cxr   julinv,dflt
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	if(dtime .le. 0.d+0) go to 800
*
	dt = dtime + .5d+0
	jdt = dt
	jdtx = jdt
	if(dt.lt.1721060.d+0)jdtx = jdtx + 2440588
*     An input smaller than 1721060 (beginning of Christian era)
c     is presumed to be a Modified Julian Day Number.
	call julinv(jdtx,  nyr,nmo,nda,  cmon,nthday)
	dfrac = dt - dflt(jdt)
	secs = 86400.d+0 * dfrac + 1.d-6
	ksecs = secs
	nhr = ksecs/3600
	min = (ksecs - 3600*nhr)/60
	nsec = ksecs - 3600*nhr - 60*min
	fksecs = ksecs
	frac = secs - fksecs
	fnsec = nsec
	sec = fnsec + frac
	if(sec.ge.60.)sec=59.99999
	return
*
800   nyr = 0
	nmo = 0
	nda = 0
	nhr = 0
	min = 0
	sec = 0
	write(*,'('' WARNING: Input to TCIVIL is bad: '',1pd20.10)')dtime
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Double Precision Function DTEPOC(dttle)
*     duplicates dtedtj
*     To convert the time of a Two-Line element yyddd.fffff... to MJDN:
	Implicit Double Precision (d)
cxr   dtmjdn
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	jepoch = dttle
	dint = jepoch
	dfrac = dttle - dint
	if(jepoch >= 70000) jepoch = jepoch + 1900000
	if(jepoch < 70000) jepoch = jepoch + 2000000
	dtepoc = dtmjdn(jepoch/1000, 0, mod(jepoch,1000),0,0,0) + dfrac
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function ARCTAN(xx,yy)
*     29 Aug 01; see Approximations for Digital Computers, Hastings.
*
	Implicit None
	Double Precision dpi,d1,dpio4,d0,dr2d,dc1,dc3,dc5,dc7,dc9
	Double Precision dc11,dc13,dc15,dx,dy,dabs,dd,dq,da,da2,dr
	Real xx,yy,arctan
*
	Parameter(dpi=3.14159265358979d+0, d1=1.d+0,
     1  dpio4=dpi/4.d+0, d0=0.d+0, dr2d=180.d+0/dpi,
     1  dc1=.9999993329d+0, dc3=-.3332985605d+0,
     2  dc5=.1994653599d+0, dc7=-.1390853351d+0, dc9=.964200441d-1,
     3  dc11=-.559098861d-1, dc13=.218612288d-1, dc15=-.4054058d-2)
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	dx = xx
	dy = yy
*
	if(dabs(dx).le.d0) then
	if(dabs(dy).le.d0) then
	write(*, '('' ARCTAN: both arguments are zero.'')')
	dd = 720.d+0
	end if
*
	dd = 90.d+0
	if(dy.lt.d0)dd = -90.d+0
*
	else
	dq  = dabs(dy/dx)
	da = (dq - d1)/(dq + d1)
	da2 = da*da
	dr = dpio4 + da*(dc1 + da2*(dc3 + da2*(dc5 + da2*(dc7 + da2*(dc9
     1  + da2*(dc11 + da2*(dc13 + da2*dc15)))))))
	dd = dr2d*dr
*
	if(dx.gt.d0)then
	if(dy.lt.d0)dd = -dd
	 else
	dd = 180.d+0 - dd
	if(dy.lt.d0) dd = -dd
	end if
	end if
*
	arctan = dd
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Integer Function JULDAY(jyear,month,jday)
*
c     1 Jun 07; logic somewhat modernized
*     27 Jun 98; 2-digit years less than 70 are construed as
c     21st century.   jyear may optionally be 4 digits to avoid
c     ambiguity.
*
c     To get the Julian day number of the day beginning
c     at 12 UT of the given calendar date.  If jyear is given with
c     only two digits, the 20th century is assumed if it is greater
c     than 69, and the 21st century otherwise.  The routine is
c     valid for any date of the Gregorian calendar later than
c     1 Jan 100 AD, and earlier than 1 Jan 4000 AD, since
c     years divisible by 4000 are common years in the Gregorian
c     calendar. If month = 0, then jday is interpreted as the numeric
c     day of the year, 1-366.
cxr   julday
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	if(jyear.lt.0 .or. month.lt.0 .or. month.gt.12) go to 160
	if(jday.le.0 .or. jday.gt.366) go to 160
	if(month.ne.0 .and. jday.gt.31) go to 160
*
	jyr = jyear
	if(jyr .lt. 70) jyr = jyr + 2000
	if(jyr .lt. 100) jyr = jyr + 1900
	kxtra = 1
	kwads = jyr/400
	jyrup = 400*kwads
	nquads = (jyr - jyrup)/4
	julian = 1721060 + 146097*kwads + 1461*nquads - nquads/25
c      1721060 is the J.D.N. of 1 Jan 0000 AD.
	if(mod(nquads,25).ne.0 .or. nquads.eq.0) go to 110
c     in a 'short' quadrennium
*
	julian = julian + 1
	kxtra = 0
c     'JULIAN' now points to the first day of the quadrennium con-
c     taining the given date.
*
110   jyrup = jyrup + 4*nquads
	nyears = jyr - jyrup
*
*     changed here 1 Jun 07
	if(nyears.ge.1 .or. (mod(jyr,100).eq.0 .and. mod(jyr,400).ne.0))
     x  then
c      Common year
	 kode = 1115212
	 julian = julian + 365*nyears + kxtra
*
	   else
c      Leap year
	 kode = 1115208
	end if
*
	if(month .le. 1) go to 140
*
	do 130 j = 2,month
	julian = julian + 31 - mod(kode,4)
130   kode = kode/4
*
140   julday = julian + jday - 1
	return
*
160   write(6,161) jyear,month,jday
161   format(' Error in arguments to JULDAY ',3i12)
	julday = 0
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
c     Vector*4 Function VEC4(x,y,z)
	Subroutine VEC4(x,y,z,  vec)
c     To return a vector whose components are x,y,z
*
	real vec(3)
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	vec(1) = x
	vec(2) = y
	vec(3) = z
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function GEODET(gcl)
*
*     To convert geocentric latitude to geodetic:
*
*  Given an elliptical earth with semi-major axis = 1, and
*  semi-minor axis = b, then from the equation of an ellipse,
*  we have
*
*  b2 x2 + y2 = b2                                  (1)
*  y = b sqrt(1 - x2)                               (2)
*  sqrt(1 - x2) = y/b                               (3)
*  dy/dx = -bx/sqrt(1 - x2)        from (2)         (4)
*
*  But the slope dy/dx of a point on the ellipse is the negative
*  reciprocal of the tangent of the geodetic latitude, i.e.
*
*  tan D = sqrt(1 - x2)/bx          where D = geodetic latitude
*  bx tan D = sqrt(1 - x2) = y/b    using (3)
*  b2 tan D = y/x
*
*  On the other hand, y/x is the tangent of the geocentric
c  latitude.  Hence
*
c   b2 tan D = tan C,   or    tan D = (tan C)/b2    (5)
*
c   which can be used to interconvert latitudes in either direction.
*
	Parameter (smajx=6378388., sminx=6356911.946,
     1  b=sminx/smajx, b2 = b*b)
c     These values of semi-major and semi-minor axis were taken
c     from  the Encyclopedia Britannica (see Geodesy).
*
*     These values are also shown as the
*     "International Ellipsoid" as defined in
*     "American Practical Navigator" (Bowditch), Pub. No. 9,
*     Volume I, p. 1119, Defense Mapping Agency.
*
	save
cxr   sine,cosine,arctan
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	gc = abs(gcl)
*
	if(gc.ge.90.)then
	 gd = 90.
	  else
	 tanc = sine(gc)/cosine(gc)
	 gd = arctan(b2, tanc)
	end if
*
	geodet = gd*sign(1., gcl)
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function ERAD84(gdlat)
*
*     28 Aug 04; added comment
*     9 Jan 03; uses the spheroid WGS 84
*     5 Jan 03; Liam Gumley reports that MODIS uses the WGS
c     spheroid of 1984, in which the Equatorial radius is
c     6378.137 km, and eccentricity .081819190843, which implies
c     a polar radius of 6356.75231424498 km, i.e.
*     b2 = a2(1 - e2)
*
c     To compute the local radius of the earth in kilometers as a
c     function of geodetic latitude:
*     See EARCOMP.hlf
*
	Implicit Double Precision (d)
*
	Parameter (dmajor=6378.137d+0, dminor=6356.752314245d+0,
     1  b = dminor/dmajor, dmaj2=dmajor*dmajor,
     2  dratio=dminor/dmajor, degrad=3.1415926535898d+0/180.d+0)
*     This is the WGS84 Spheroid.
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	if(abs(gdlat) .gt. 90.) then
	write(*, '('' ERAD84: Given Latitude Is Out of Range: '',
     1  1pe16.4)') gdlat
	erad84 = -1.
	end if
*
	gclat = geocen(gdlat)
*     converts to geocentric
	dxe = dmajor * dcos(degrad * gclat)
	dxe2 = dxe*dxe
	dye = dratio*dsqrt(dmaj2 - dxe2)
	erad84 = dsqrt(dxe2 + dye*dye)
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function SINE(xx)
*     Argument in degrees
*
	Implicit Double Precision(d)
	Parameter( dc = 3.141592653589793d+0/180.d+0)
c     xxxxxxxxxxxxxxxxxxxxxxxxxx
	dxx = xx
	ds = dsin(dc*dxx)
	sine = ds
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function COSINE(xx)
*
	Implicit Double Precision(d)
	Parameter( dc = 3.141592653589793d+0/180.d+0)
c     xxxxxxxxxxxxxxxxxxxxxxxxx
	dxx = xx
	ds = dcos(dc*dxx)
	cosine = ds
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function GEOCEN(gdl)
*
*     See GEODET for explanation of this algorithm.
*
	Implicit None
	Real gdl,gd,abs,gc,tand,sine,cosine,arctan,b2,geocen,sign,
     1  smajx,sminx,b
*
	parameter (smajx=6378388., sminx=6356911.946,
     1  b=sminx/smajx, b2 = b*b)
cxr   sine,arctan,cosine
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	gd = abs(gdl)
*
	if(gd.ge.90.)then
	gc = 90.
	 else
	tand = sine(gd)/cosine(gd)
	gc = arctan(1., b2*tand)
	end if
*
	geocen = gc*sign(1., gdl)
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Real Function VERNEQ(dt)
*
cxr   dfrac
*     To return the longitude (positive east) of the Vernal Equinox
c     at the given time dt, expressed either as JDN or MJDN:
*     See page 37  Montenbruck & Pfleger
*
*     Compared with old VERNEQ.for  9 Dec 91;  constant error of
c     .003 deg;  looks OK.
*
*     No adjustment is made for leap seconds.
*
	Implicit None
	Double Precision dt,mjd,mjd0,dint,ut,t,gst,gstc,dfrac,ve
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	mjd = dt - 2400000.5d0
	if(dt .lt. 1721060.d+0) mjd = mjd + 2440588
	mjd0 = dint(mjd)
	ut = 24.d0 * (mjd - mjd0)
	t = (mjd0 - 51544.5d0)/36525.d0
	gst = 6.697374558d0 + 1.0027379093d0 * ut
     1 + (8640184.812866d0 + (.093104d0 - 6.2d-6*t)*t)*t/3600.
c     There are 1.0027379093 sidereal days per mean solar day.
	gstc = dfrac(gst/24.d0)
	ve = 360. * (1.d0 - gstc)
	if(ve .gt. 180.d0) ve = ve - 360.
	verneq = ve
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Subroutine JULINV(julin, ky,km,kd, cmon,nth)
*
*     To convert the Julian Day Number (JDN) to civil date:
*     7 Aug 98; tested using JULTEST
*     This routine works for years 4 AD to 3999 AD.
*     A 4-digit year ky is returned.  The returned ASCII month is of
*     the form ' Jan', i.e. character*4 with a lead blank.  nth
*     is the day of the year (1-366).
*
	Implicit None
	Integer jdn,julin,ndce,kwads,nrem,long,ncents,kq0001,nquads
	Integer kq0002,kyear,kq0003,kym1,leap,mod,kode,nth,mm,m
	Integer ndm,kd,km,ky
	character*4 cmon,cmons(12)
	integer jqmax/z'7fffffff'/
*
	data cmons/' Jan',' Feb',' Mar',' Apr',' May',' Jun',' Jul',
     1  ' Aug',' Sep',' Oct',' Nov',' Dec'/
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	jdn = julin
	if(jdn.lt.1721060 .or. jdn.gt.3182410) go to 900
*
	ndce = jdn - 1721060
	kwads = ndce/146097
	nrem = ndce - 146097*kwads
	long = 1
	ncents = 0
*
	do   2 kq0001 = 1,jqmax
*      nrem = & - (36524 + long)
	 nrem = nrem-(36524+long)
	 if(nrem.lt.0) go to   4
*
	 long = 0
2     ncents = ncents+1
*
4     nrem = nrem + (36524 + long)
	nquads = 0
*
	do   6 kq0002 = 1,jqmax
	nrem = nrem-(1460+long)
	if(nrem.lt.0) go to   8
*
	 long = 1
6     nquads = nquads+1
*
8     nrem = nrem + (1460 + long)
	kyear = 400*kwads + 100*ncents + 4*nquads
	long = 1
*
	do  10 kq0003 = 1,jqmax
	nrem = nrem-(365+long)
	if(nrem.lt.0) go to  12
*
	 long = 0
10    kyear = kyear+1
*
12    nrem = nrem+(365+long)
	kym1 = kyear - 1
	leap = (mod(kym1,4)+1)/4 - (mod(kym1,100)+1)/100
     1  + (mod(kym1,400)+1)/400
	kode = 1115212 - 4*leap
	nth = nrem + 1
*
	do  14 m = 1,12
	 mm = m
	 ndm = 31 - mod(kode,4)
	 nrem = nrem-ndm
	 if(nrem.lt.0) go to  16
*
14    kode = kode/4
*
16    nrem = nrem+ndm
	kd = nrem + 1
	km = mm
	cmon = cmons(mm)
	ky = kyear
	return
*
900   write(*, '('' JULINV: JDN out of range:'', i14)') jdn
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Double Precision Function DFLT(narg)
c     DFLOAT does not work on some Unix platforms
	Double Precision dd
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	dd = narg
	dflt = dd
	return
	end
*      rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Double Precision Function DFRAC(ditem)
*
*     The function returns the fraction from the algebraically
*     lesser integer, i.e.
*
c     1.7 ===> .7   and   -1.7 ===> .3
*
	Implicit Double Precision (a-h,o-z)
cxr   dflt
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	df = ditem
*
	if(dabs(df) .gt. 2147483647.9999d0) then
	write(*, '('' DFRAC: argument is too large: '', d20.10)') df
	dfrac = 999999999.
*
	  else
	item = df
	df = df - dflt(item)
	if(df .lt. 0.d+0) df = df + 1.d+0
	dfrac = df
	end if
*
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Real Function ANG4QQ(V1,V2)
*
*     30 Nov 07; virtually the same as ANGBTW
*     To compute the Real*4 angle in degrees between two  Vector*4:
*     This function is invoked by MeteFor's ^ operator, e.g. VA^VB
*
	Implicit None
	Double Precision dot,rq81,da1,da2,darg,d0,dtest,dsqrt,dabs
	Double Precision d1,dsign,dc,dacos
*
	parameter(dc = 180.d+0/3.141592653589793d+0, d0=0.d+0,
     1  d1=1.d+0)
	double precision vv1(3),vv2(3)
	real  v1(3),v2(3)
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	vv1(1) = v1(1)
	vv1(2) = v1(2)
	vv1(3) = v1(3)
*
	vv2(1) = v2(1)
	vv2(2) = v2(2)
	vv2(3) = v2(3)
*
	dot=vv1(1)*vv2(1)+vv1(2)*vv2(2)+vv1(3)*vv2(3)
	da1=vv1(1)*vv1(1)+vv1(2)*vv1(2)+vv1(3)*vv1(3)
	da2=vv2(1)*vv2(1)+vv2(2)*vv2(2)+vv2(3)*vv2(3)
	darg = da1*da2
*
	if(darg.le.d0)then
	write(*, '('' ANG4QQ: an argument is zero '')')
	ang4qq = 360.
*
	else
	dtest = dot/dsqrt(darg)
	if(dabs(dtest).gt.d1) dtest=dsign(d1,dtest)
	ang4qq = dc*dacos(dtest)
	end if
*
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function RV4QQ(VEC)
*     to compute the length of a Vector*4:
*     This is normally invoked by the MeteFor [...] operator
*
	real vec(3)
	equivalence(sum,jsum), (r1,jr1)
c     xxxxxxxxxxxxxxxxxxxxxxxxxx
	r1 = 0.
	sum = vec(1)*vec(1) + vec(2)*vec(2) + vec(3)*vec(3)
*
	if(sum.gt.0.) then
	jr1 = jsum/2 + 536870912
*
	do 2 n = 1,6
	r0 = r1
2     r1 = .5*(sum/r0 + r0)
*
	end if
*
	rv4qq = r1
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Character*132 Function CAPLET(cvar,length)
c     To convert any lower case ASCII letters to capitals
	character*132 cvar,cout
	character*1 cc,char
	save
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	if(length.lt.1 .or. length.gt.132) then
	write(*, '('' CAPLET: The length must be > 0 and <= 132'')')
	cout = ' '
	go to 102
	end if
*
	cout = ' '
	cout(1:length) = cvar(1:length)
*
	do  j = 1,length
	 cc = cout(j:j)
	 ich = ichar(cc)
	 if(ich.ge.97 .and. ich.le.122) cout(j:j) = char(ich-32)
	end do
*
102   caplet = cout
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
*     VECTOR FUNCTION VNORAX(DT,CSATX,  SLAT,SLONG,CDT)
	SUBROUTINE VNORAX(DT,CSATX,SLAT,SLONG,CDT,VQORAX)
*
*     FUNCTION:
*
*     This routine computes the past or future position of
*     any of several satellites at a given time, returning the
*     results as latitude/longitude, or as a 3-dimensional
*     vector in the celestial coordinate system.   The calculation
*     is based on the NORAD-developed routine SGP8.
*     A detailed document in Acrobat format exists describing the
*     NORAD-developed routines (spacetrk.pdf).
*
*     INPUTS:
*
*     dt (Double Precision or Real(double)):
*     The time for which a predicted satellite position is
*     wanted, expressed in Modified Julian Day Number (MJDN).
*     For an explanation of MJDN, see the ASCII document
*     Julian.Day.Number, and the routine dtmjdn.f
*
*     csatx (character*8):
*     The identifier for the satellite (e.g. NOAA11, DMSP14, etc)
*
*     OUTPUTS:
*
*    slat(real or real(single)):
*    satellite geocentric latitude
*
*    slong (real or real(single)):
*    satellite longitude
*
*    cdt (real or real(single)):
*    central distance, measured from the center of the earth
*    to the satellite, in kilometers.
*
*    V$ORAX (Vector*8 or real(single), dimension=3):
*    The vector position of the satellite in celestial coordinates.
*
*     Note: The needed orbital parameters must exist in the NORAD
*     two-line element format in the file TLINSET.
*
*     PROGRAMMER: F W Nagle, SSEC
*
*     Note: This routine is invoked as a Vector-Valued Function by
c     a High-Level Fortran (HLF) program.
cxr   inparm,sgp4
c     cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	implicit double precision(d)
	parameter (nmax=24)
	character*8 csat,csatx,cslast,csats
	character*132 caplet
	real de2ra,buf(13)
	real vqorax(3)
*     VECTOR (F)VCOORD
	real vq41(3)
	real  vsat(3),vll(3)
	dimension csats(nmax),parms(13,nmax)
	common/e1/dtelem,ds50,xmo,xnodeo,omegao,eo,xincl,xno,xndt2o,xndd60
     x,bstar,x,y,z,xdot,ydot,zdot
	common/tle/csats,parms
	common/c1/ck2,ck4,e6a,qoms2t,s,tothrd,xj3,xke,eqrad,xmnpda,ae
	common/c2/de2ra,pi,pio2,twopi,x3pio2
	equivalence(buf(1),dtelem)
	save
	data init/0/
	data  cslast/' '/
	data xj2,xj4,qo,so/1.082616e-3, -1.65597e-6,120., 78./
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	if(init.eq.0)then
	instal = 0
*
	do   2 j=1,nmax
2     csats(j) = ' '
*
	end if
*
	jsat = 0
	csat = csatx
	csat=caplet(csat,8)
	iflag = 0
*
	if(csat.eq.' ')then
*
	do   4 j=1,nmax
4     csats(j) = ' '
*
*      VNORAX = 0.
	 vqorax(1)=0.
	 vqorax(2)=0.
	 vqorax(3)=0.
	 cslast = ' '
	 init = 0
	 instal = 0
	 cdt = 0.
	 go to 102
	end if
*
	if(csat.ne.cslast)then
	 iflag = 1
	 cslast = csat
	end if
*
	do   6 n=1,nmax
*
	if(csats(n).eq.csat)then
	  jsat = n
	  kfetch = 0
	go to     8
	end if
*
    6 continue
*
    8 continue
*
	if(jsat.eq.0)then
	 kfetch = 1
*
	do  10 i=1,nmax
	if(csats(i).ne.' ')go to    10
*
	  jsat = i
	  csats(i) = csat
	go to    12
   10 continue
*
   12 continue
*
	if(jsat.eq.0)then
	write(*, '('' VNORAX: There is no slot available for this '',
     1  ''satellite: '', a8)') CSAT
*     VNORAX = 0.
	vqorax(1)=0.
	vqorax(2)=0.
	vqorax(3)=0.
	go to 102
	end if
	end if
*
	call tcivil(dt, ny,nm,nd,km,km,sec,nth)
*
	if(kfetch.gt.0)then
	 jymd = 10000*ny + 100*nm + nd
*
	if(inparm(jymd,csat).ne.0)then
	 write(*, '('' VNORAX: Error return from INPARM '')')
*
*      VNORAX = 0.
	vqorax(1)=0.
	vqorax(2)=0.
	vqorax(3)=0.
	 cdt = 0.
	 go to 102
	end if
*
	do  14 i=1,13
14    parms(i,jsat) = buf(i)
*
	end if
*
	do  16 i=1,13
16     buf(i) = parms(i,jsat)
*
	 iflag = 1
	 instal = jsat
	 jte = dtelem
	 dtf = dtelem - dflt(jte)
	 dtepoc = dtmjdn(jte/1000, 0, mod(jte,1000), 0,0,0) + dtf
	tsince = 1440.d+0 * (dt - dtepoc)
	call sgp4(iflag,tsince)
	xdot = xdot * eqrad / 60.
	ydot = ydot * eqrad / 60.
	zdot = zdot * eqrad / 60.
	vsat(1) = eqrad*x
	vsat(2) = eqrad*y
	vsat(3) = eqrad*z
*     VLL = VCOORD(DT, VSAT, 'CLL')
	call vcoord(dt,vsat,'CLL',vll)
*
	slat = vll(1)
	slong = vll(2)
	cdt = vll(3)
*     VNORAX = VSAT
	vqorax(1) = vsat(1)
	vqorax(2) = vsat(2)
	vqorax(3) = vsat(3)
	init = 1
*
102   return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	FUNCTION INPARM(JYMD,CSAT)
*
c     23 Jan 08; in util.a
*    Orbital parameters (2-line elements) are available
*    through the web site:  celestrak.com/pub/elements/weather.txt
*
*     To install orbital parameters from the 2-line element file:
*     This routine may fail if it is called from an arbitrary
c     program.  It is properly called only from VNORAD or another
c     routine which properly initiates the common blocks.
*
*     The requested date jymd is in the form (yy)yymmdd, and the
c     satellite identifier is character*8, e.g. NOAA11, DMSP14, etc.
*
*     The returned functional value is zero if parameters were
c     correctly installed, and one otherwise.
c     --------------------------------------------------
	implicit double precision(d)
	character*8 csat,cloc
	character*80 cline
	character*132 caplet
	real buf(13),hold(13),de2ra
	logical lexist
	integer jqmax/z'7fffffff'/
	common/e1/dtelem,ds50,xmo,xnodeo,omegao,eo,xincl,xno,xndt2o,xndd60
     x,bstar,x,y,z,xdot,ydot,zdot
	equivalence(buf(1),dtelem)
	common/c1/ck2,ck4,e6a,qoms2t,s,tothrd,xj3,xke,eqrad,xmnpda,ae
	common/c2/de2ra,pi,pio2,twopi,x3pio2
	save
*
	data xj2,xj4,qo,so/1.082616e-3, -1.65597e-6,120., 78./
	data init/0/
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	if(init.eq.0)then
	inquire(file='TLINSET', exist=lexist)
*
	if(.not.lexist)then
	write(*, '('' The Two-Line Element File TLINSET is required,''/
     1  '' but does not exist.''/)')
	dtelem = -1.d+0
	go to 202
	end if
*
	 e6a = 1.e-6
	 pi = 3.14159265
	 de2ra = pi/180.
	 pio2 = pi/2.
	 tothrd = .66666667
	 twopi = 2.*pi
	 x3pio2 = 3.*pio2
	 xj3 = -.253881e-5
	 xke = .743669161e-1
	 eqrad = 6378.135
	 xmnpda = 1440.
	 ae = 1.
	 ck2 = .5*xj2
	 ck4 = -.375*xj4
	 qoms2t = ((qo - so)/eqrad)**4
	 s = (1. + so/eqrad)
	 init = 1
	end if
*
	inp = 1
	cloc = ' '
*
	if(abs(pi-3.14159).gt..001.or.abs(xmnpda-1440.).gt..1)then
	 write(*, '('' INPARM: common blocks c1 and c2 appear not''/
     1  '' to be properly initialized.''/)')
	 write(*,'('' INPARM should be called by VNORAD/VNORAX.'')')
	 go to 202
	end if
*
	do   2 i=1,8
	if(csat(i:i).eq.' ')go to 4
*
2      cloc(i:i) = csat(i:i)
*
4     nth = nthday(jymd/10000, mod(jymd/100,100), mod(jymd,100))
	jyyddd = 1000*(jymd/10000) + nth
*
	if(jyyddd.lt.100000)then
	if(jyyddd.gt.70000)jyyddd=jyyddd+1900000
	if(jyyddd.le.70000)jyyddd=jyyddd+2000000
	end if
*
	cloc=caplet(cloc,8)
	if(isopen(58).eq.0)open(58,file='TLINSET',
     x form='formatted',STATUS='old',ACCESS='sequential')
	relmin = 1.e+30
	kfound = 0
	dtymd = dtmjdn(jyyddd/1000, 0, mod(jyyddd,1000), 0,0,0)
*
	do 6 kq0001 = 1,jqmax
	 read(58, '(a80)',end=990,err=992) cline
	 kpat = kpattn(cline,80,cloc,8,0)
*
	if(kpat.eq.0)go to 6
*
	 kfound = 1
	 read(58,'(18x,d14.8,1x,f10.8,2(1x,f6.5,i2))',end=992,err=980)
     1  dtelem,xndt2o,xndd60,iexp,bstar,ibexp
	 read(58, '(7x, 2(1x,f8.4), 1x, f7.7, 2(1x,f8.4), 1x, f11.8)',
     x  err=982)
     1  xincl,xnodeo,eo,omegao,xmo,xno
	 jepoch = dtelem
	if(jepoch.ge.70000) jepoch=jepoch+1900000
	if(jepoch.lt.70000) jepoch=jepoch+2000000
	 dtep = dtmjdn(jepoch/1000, 0, mod(jepoch,1000),0,0,0)
	 rel = dtymd - dtep
	if(abs(rel).lt.1.) go to 20
	if(rel.lt.0..and.abs(rel).gt.relmin) go to 990
*
	if(abs(rel).lt.relmin)then
	 relmin = abs(rel)
*
	do   8 i=1,13
8     hold(i) = buf(i)
*
	end if
*
    6 continue
*
	write(*, '('' INPARM: no elements found for '', i10)') jymd
	dtelem = -1.d+0
	go to 202
*
20    xndd60 = xndd60*(10.**iexp)
	xnodeo = xnodeo*de2ra
	omegao = omegao*de2ra
	xmo = xmo*de2ra
	xincl = xincl*de2ra
	temp = twopi/(xmnpda*xmnpda)
	xno = xno*temp*xmnpda
	xndt2o = xndt2o*temp
	xndd60 = xndd60*temp/xmnpda
	a1 = (xke/xno)**tothrd
	temp = 1.5*ck2*(3.*cos(xincl)**2-1.)/(1.-eo*eo)**1.5
	del1 = temp/(a1*a1)
	ao  = a1*(1. - del1*(.5*tothrd + del1*(1. + 134.*del1/81.)))
	delo = temp/(ao*ao)
	xnodp = xno/(1.+delo)
	ideep = 0
	if(twopi/(xnodp*xmnpda).ge..15625)ideep=1
*
	if(ideep.gt.0)then
	write(*, '('' This orbit requires deep space logic'')')
	dtelem = -1.d+0
	go to 202
	end if
*
	bstar = bstar*(10.**ibexp)/ae
	close(58)
	inp = 0
*
202   inparm = inp
	return
*
990   if(kfound.eq.0)then
	write(*, '('' INPARM: no parameters found for this satellite: '',
     1  a8)') csat
	dtelem = -1.d+0
	go to 202
	end if
*
	do  10 i=1,13
10    buf(i) = hold(i)
*
	go to 20
*
992   write(*, '('' INPARM input error '')')
	kfound = 0
	go to 990
*
980   backspace(58)
	read(58,*) cline
	write(*,'('' INPARM: Error in reading Line 1 of elements:''/1h ,a80)')
     x  cline
	go to 992
*
982   backspace(58)
	read(58,*) cline
	write(*,'('' INPARM: Error in reading Line 2 of elements:''/1h ,a80)')
     x  cline
	go to 992
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Subroutine SGP4(iflag,tsince)
*
c     26 Nov 07; tested using NORPASS; looks OK, recommended by Kelso;
*       in util.a on laptop
*
*     This routine was written by NORAD, not by SSEC.
*
*     The flag 'iflag' should be 1 on the first call to perform
c     needed initialization, and zero thereafter.
*     The input argument 'tsince' is time since epoch in
c     minutes.  It may be positive or negative.
*
*     The output vectors are celestial, not terrestrial.
*     The position vector uses earth-radius as its unit of length
*     The veclocity vector (returned thru common) is in
c     radians/minute.    See common/e1/ for outputs.
*
*     11 Dec 98; received from UW astronomy department, via FTP
c       from sal.wisc.edu; sign in as anonymous; go to the
c       directory pub/jwp; then FTP the file spacetrk.zip;  use
c       the command 'unzip' on Unix
*
*     Input time 'tsince' is in minutes since epoch, and
c     may be positive or negative.
*
	double precision epoch, ds50
	common/e1/epoch,ds50,xmo,xnodeo,omegao,eo,xincl,xno,xndt2o,
     1   xndd6o,bstar,x,y,z,xdot,ydot,zdot
*     23 Dec 98; epoch,ds50 moved to front of common block to
c     avoid bad alignment
*
	common/c1/ck2,ck4,e6a,qoms2t,s,tothrd,
     1   xj3,xke,xkmper,xmnpda,ae
	save
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	if (iflag .eq. 0) go to 100
*
*      Recover original mean motion (xnodp) and semimajor axis (aodp)
*      from input elements
	a1 = (xke/xno)**tothrd
	cosio = cos(xincl)
	theta2 = cosio*cosio
	x3thm1 = 3.*theta2-1.
	eosq = eo*eo
	betao2 = 1.-eosq
	betao = sqrt(betao2)
	del1 = 1.5*ck2*x3thm1/(a1*a1*betao*betao2)
	ao = a1*(1. - del1*(.5*tothrd + del1*(1. + 134./81.*del1)))
	delo = 1.5*ck2*x3thm1/(ao*ao*betao*betao2)
	xnodp = xno/(1.+delo)
	aodp = ao/(1.-delo)
*
*      Initialization
*
*   For perigee less than 220 kilometers, the isimp flag is set and
*   the equations are truncated to linear variation in sqrt a and
*   quadratic variation in mean anomaly.  Also, the c3 term, the
*   delta omega term, and the delta m term are dropped.
*
	isimp=0
	if((aodp*(1.-eo)/ae) .lt. (220./xkmper+ae)) isimp=1
*
*      For perigee below 156 km, the values of
*      s and qoms2t are altered
*
	s4 = s
	qoms24 = qoms2t
	perige = (aodp*(1.-eo)-ae)*xkmper
	if(perige .ge. 156.) go to 10
*
	s4 = perige-78.
	if(perige .gt. 98.) go to 9
*
	s4 = 20.
*
    9 qoms24 = ((120.-s4)*ae/xkmper)**4
	s4 = s4/xkmper+ae
*
   10 pinvsq = 1./(aodp*aodp*betao2*betao2)
	tsi = 1./(aodp-s4)
	eta = aodp*eo*tsi
	etasq = eta*eta
	eeta = eo*eta
	psisq = abs(1.-etasq)
	coef = qoms24*tsi**4
	coef1 = coef/psisq**3.5
	c2 = coef1*xnodp*(aodp*(1. + 1.5*etasq + eeta*(4. + etasq)) + .75*
     1   ck2*tsi/psisq*x3thm1*(8. + 3.*etasq*(8. + etasq)))
	c1 = bstar*c2
	sinio = sin(xincl)
	a3ovk2 = -xj3/ck2*ae**3
	c3 = coef*tsi*a3ovk2*xnodp*ae*sinio/eo
	x1mth2 = 1.-theta2
	c4 = 2.*xnodp*coef1*aodp*betao2*(eta*
     1    (2.+.5*etasq)+eo*(.5+2.*etasq)-2.*ck2*tsi/
     2    (aodp*psisq)*( - 3.*x3thm1*(1. - 2.*eeta + etasq*
     3    (1.5-.5*eeta))+.75*x1mth2*(2.*etasq-eeta*
     4    (1.+etasq))*cos(2.*omegao)))
	c5 = 2.*coef1*aodp*betao2*(1.+2.75*(etasq+eeta)+eeta*etasq)
	theta4 = theta2*theta2
	temp1 = 3.*ck2*pinvsq*xnodp
	temp2 = temp1*ck2*pinvsq
	temp3 = 1.25*ck4*pinvsq*pinvsq*xnodp
	xmdot = xnodp + .5*temp1*betao*x3thm1 + .0625*temp2*betao*
     1     (13. - 78.*theta2 + 137.*theta4)
	x1m5th=1.-5.*theta2
	omgdot=-.5*temp1*x1m5th + .0625*temp2*(7.-114.*theta2 +
     1     395.*theta4) + temp3*(3.-36.*theta2 + 49.*theta4)
	xhdot1=-temp1*cosio
	xnodot=xhdot1 + (.5*temp2*(4.-19.*theta2) + 2.*temp3*(3.-
     1   7.*theta2))*cosio
	omgcof = bstar*c3*cos(omegao)
	xmcof = -tothrd*coef*bstar*ae/eeta
	xnodcf = 3.5*betao2*xhdot1*c1
	t2cof = 1.5*c1
	xlcof = .125*a3ovk2*sinio*(3.+5.*cosio)/(1.+cosio)
	aycof = .25*a3ovk2*sinio
	delmo = (1.+eta*cos(xmo))**3
	sinmo = sin(xmo)
	x7thm1 = 7.*theta2-1.
	if(isimp .eq. 1) go to 90
*
	c1sq=c1*c1
	d2=4.*aodp*tsi*c1sq
	temp=d2*tsi*c1/3.
	d3=(17.*aodp + s4)*temp
	d4=.5*temp*aodp*tsi*(221.*aodp + 31.*s4)*c1
	t3cof=d2 + 2.*c1sq
	t4cof=.25*(3.*d3 + c1*(12.*d2+10.*c1sq))
	t5cof=.2*(3.*d4 + 12.*c1*d3 + 6.*d2*d2 + 15.*c1sq*(
     1     2.*d2+c1sq))
   90 iflag=0
*
*      Update for secular gravity and atmospheric drag
*
  100 xmdf = xmo + xmdot*tsince
	omgadf = omegao + omgdot*tsince
	xnoddf = xnodeo + xnodot*tsince
	omega = omgadf
	xmp = xmdf
	tsq = tsince*tsince
	xnode = xnoddf + xnodcf*tsq
	tempa = 1.-c1*tsince
	tempe = bstar*c4*tsince
	templ = t2cof*tsq
	if(isimp .eq. 1) go to 110
*
	delomg = omgcof*tsince
	delm = xmcof*((1. + eta*cos(xmdf))**3-delmo)
	temp = delomg + delm
	xmp = xmdf + temp
	omega = omgadf-temp
	tcube = tsq*tsince
	tfour = tsince*tcube
	tempa = tempa-d2*tsq-d3*tcube-d4*tfour
	tempe = tempe + bstar*c5*(sin(xmp)-sinmo)
	templ = templ + t3cof*tcube +
     1   tfour*(t4cof + tsince*t5cof)
*
110   a = aodp*tempa**2
	e = eo - tempe
	xl = xmp + omega + xnode + xnodp*templ
	beta = sqrt(1.-e*e)
	xn = xke/a**1.5
*
*      long period periodics
*
	axn = e*cos(omega)
	temp = 1./(a*beta*beta)
	xll = temp*xlcof*axn
	aynl = temp*aycof
	xlt = xl + xll
	ayn = e*sin(omega)+aynl
*
*      Solve Kepler's equation
*
	capu = fmod2p(xlt-xnode)
	temp2 = capu
*
	do 130 i = 1,10
	sinepw = sin(temp2)
	cosepw = cos(temp2)
	temp3 = axn*sinepw
	temp4 = ayn*cosepw
	temp5 = axn*cosepw
	temp6 = ayn*sinepw
	epw = (capu-temp4+temp3-temp2)/(1.-temp5-temp6)+temp2
	if(abs(epw-temp2) .le. e6a) go to 140
*
  130 temp2=epw
*
*      short period preliminary quantities
*
  140 ecose = temp5+temp6
	esine = temp3-temp4
	elsq = axn*axn+ayn*ayn
	temp = 1.-elsq
	pl = a*temp
	r = a*(1.-ecose)
	temp1 = 1./r
	rdot = xke*sqrt(a)*esine*temp1
	rfdot = xke*sqrt(pl)*temp1
	temp2 = a*temp1
	betal = sqrt(temp)
	temp3 = 1./(1.+betal)
	cosu = temp2*(cosepw-axn+ayn*esine*temp3)
	sinu = temp2*(sinepw-ayn-axn*esine*temp3)
*     u = actan(sinu,cosu)
	u = .0174532925*arctan(cosu,sinu)
	if(u .lt. 0.) u = u + 6.2831853
*     To simulate ACTAN, which returns 0 to 2*pi
	sin2u = 2.*sinu*cosu
	cos2u = 2.*cosu*cosu-1.
	temp = 1./pl
	temp1 = ck2*temp
	temp2 = temp1*temp
*
*      Update for short periodics
*
	rk = r*(1.-1.5*temp2*betal*x3thm1)+.5*temp1*x1mth2*cos2u
	uk = u-.25*temp2*x7thm1*sin2u
	xnodek = xnode+1.5*temp2*cosio*sin2u
	xinck = xincl+1.5*temp2*cosio*sinio*cos2u
	rdotk = rdot-xn*temp1*x1mth2*sin2u
	rfdotk = rfdot + xn*temp1*(x1mth2*cos2u + 1.5*x3thm1)
*
*      orientation vectors
	sinuk = sin(uk)
	cosuk = cos(uk)
	sinik = sin(xinck)
	cosik = cos(xinck)
	sinnok = sin(xnodek)
	cosnok = cos(xnodek)
	xmx = -sinnok*cosik
	xmy = cosnok*cosik
	ux = xmx*sinuk + cosnok*cosuk
	uy = xmy*sinuk + sinnok*cosuk
	uz = sinik*sinuk
	vx = xmx*cosuk - cosnok*sinuk
	vy = xmy*cosuk - sinnok*sinuk
	vz = sinik*cosuk
*
*      position and velocity
	x = rk*ux
	y = rk*uy
	z = rk*uz
*     write(*, '('' lv sgp4, tsince,x,y,x '', e14.7,3f10.3)')
*    x  tsince,x,y,z
	xdot = rdotk*ux + rfdotk*vx
	ydot = rdotk*uy + rfdotk*vy
	zdot = rdotk*uz + rfdotk*vz
*
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function LNGTST(west, flong, east)
c     23 Dec 07; used in Mercorb, but not totally foolproof
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	w = west
	e = east
	test = flong
	lng = 0
*
2     if(e .lt. w) then
	e = e + 360.
	go to 2
	end if
*
	if(test .gt. e) test = test - 360.
	if(test .lt. w) test = test + 360.
	if(test.ge.w .and. test.le.e) lng = 1
*
	lngtst = lng
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function NSCAN(kol,card)
*
*     28 Jun 06; corrected error involving minus sign; see below
*     15 Jun 06; modified to accept minus sign
*     Derived from NSCAN.hlf, used in McEDIT
*
*     This function will scan across blanks on an ASCII line
c     to find the next numeric field, from which it will compute
c     a binary value.  kol does not need to be set to the
*     beginning of the next ASCII integer value.
*
	character*1 card,ch
	dimension card(32)
	data n0,n9/48,57/
c     xxxxxxxxxxxxxxxxxxxxxxxxxxx
	mag = 0
	kmag = 0
	jsign = 1
*
	do 10 n = 1,16
	ch = card(kol)
*
*    Find the start of the next integer field:
	if(ch .eq. ' ') then
*     28 Jun 06; changed here:
	if(kmag.eq.0 .and. jsign.gt.0) go to 10
	go to 22
	end if
*
	if(ch .eq. '-') then
	jsign = -1
	go to 10
	end if
*
	ich = ichar(ch)
	if(ich.lt.n0 .or. ich.gt.n9) go to 22
	kmag = 1
	mag = 10*mag + ich - n0
10    kol = kol + 1
*
22    nscan = jsign*mag
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function FMOD2P(x)
*     Used in connection with NORAD SGP and SGP4
*     This routine was not written by SSEC
*
	common/c2/de2ra,pi,pio2,twopi,x3pio2
	save
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	fmod2p = x
	i = fmod2p/twopi
	fmod2p = fmod2p-i*twopi
	if(fmod2p.lt.0) fmod2p = fmod2p+twopi
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function NTHDAY(ny,nm,nd)
*
c     31 May 04; if,then  ===> go to
*     This function returns the day of the year (1-366), given
c     the civil year,month,day.
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	kode = 1115212
	if(mod(ny,4).eq.0 .and. mod(ny,100).ne.0) kode = 1115208
	if(mod(ny,400) .eq. 0) kode = 1115208
	nth = nd
*
	if(nm .gt. 1) then
	nth = 0
	m = nm - 1
*
	do 110 j = 1,m
	nth = nth + 31 - mod(kode,4)
110   kode = kode/4
*
	nth = nth + nd
	end if
*
	nthday = nth
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function ISOPEN(lun)
*     To ascertain if logical unit number lun is open:
c     (1=yes, 0=no)
*
	logical lopen
c     xxxxxxxxxxxxxxxxxxxxx
	inquire(lun, opened=lopen)
	iset = 0
	if(lopen) iset = 1
	isopen = iset
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function KPATTN(cline,lenli,cpat,leng,kode)
*
*     To find the column (1-lenli) where a given pattern begins
*     If kode=0, searches for exact pattern in 'cpat'
c     If kode!=0, disregards lower/upper case, i.e.  xyz = XYZ
*     If the pattern does not exist, zero is returned.
*     leng  is the length of the pattern, with maximum 24.
*
	character*132 cline,caplet
	character*24 csub,cpatl,cpat
cxr   caplet
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	len = leng
	if(len.gt.24)len=24
	cpatl = ' '
	cpatl = cpat(1:len)
	if(kode.ne.0)cpatl=caplet(cpatl,len)
*
	do   2 k=1,lenli
	 k1 = k
	 k2 = k1 + len - 1
*
	if(k2.gt.lenli)go to 4
*
	 csub = cline(k1:k2)
	if(kode.eq.1)csub=caplet(csub,len)
	if(csub.eq.cpatl) go to 20
*
    2 continue
*
    4 continue
	kpattn = 0
	return
*
20    kpattn = k1
	return
	end
c     rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
	Function ARGNUM(jpos)
c
*     15 Jun 06 - uses new nscan
	character*24 cin
cxr   nscan
c     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	call getarg(jpos, cin)
	kol = 1
	num = nscan(kol,cin)
*     num may be negative
	argnum = num
	return
	end
